#!/usr/bin/env nix-shell
#!nix-shell -i python -p "python38.withPackages(ps : with ps; [ noise ])"

# should we use opensimplex instead…?


import sys
import time
import struct
import colorsys
from socket import *

from noise import pnoise3


def noise(x, y, z):
  out = abs(pnoise3(x, y, z, persistence=1.0, lacunarity=1.0, octaves=1))

  # out += 1
  # out /= 2

  # out *= 32
  # out /= 32


  return out



port = 4213
hosts = ['192.168.0.108']

fps = 60
step = 1 / 512


s = socket(AF_INET, SOCK_DGRAM)

def f2b(f):
  return bytearray(struct.pack("f", f))


def send(*x):

  data = b'fxCyanF'

  for _x in x:
    data += f2b(_x)

  for host in hosts:
    try:
      s.sendto(data, (host, port))
    except:
      pass


def hsv(h, s, v):
  return list(colorsys.hsv_to_rgb(h, s, v))


####################
####################


# purple color fading
def anim0(f):
  z = f * step

  return [
    noise(0.0, -0.42, z),
    0,
    noise(0.0,  0.42, z),
  ]


# HSV mapped fading with perlin brightness
def anim1(perlinBrightness=True):

  def _anim(f):
    z = f * step

    if perlinBrightness:
      v = noise(0.0, 0.42, z)
    else:
      v = 1.0

    return hsv(noise(0.42, 0.69, z), 1.0, v)

  return _anim



f = 0

anim = anim1(True)

while True:

  # print(*anim(f))
  send(*anim(f))

  f += 1

  time.sleep(1/fps)




