#!/usr/bin/env nix-shell
#!nix-shell -i python -p python3

import sys
import time
import struct
from socket import *


port = 4213
hosts = ['192.168.0.115']

fps = 60
step = 1 / 32


s = socket(AF_INET, SOCK_DGRAM)

def f2b(f):
  return bytearray(struct.pack("f", f))


def send(x):
  data = f2b(x)

  for _ in range(5):
    data += f2b(0.0)

  data = bytearray(b'fxCyanF') + data

  for host in hosts:
    try:
      s.sendto(data, (host, port))
    except:
      pass


t = 1 * 60**2  # seconds


if len(sys.argv) > 1:
  if sys.argv[1] == 'up':
    countDown = False
  else:
    countDown = True
else:
  countDown = True


if len(sys.argv) > 2:
  t = int(sys.argv[2]) * 60


bits = 16
step = 2**bits / t / 10 / 2**bits
print('step: ' + str(step))

x = 1.0
i = 0
while x > 0.0:
  if countDown:
    send(x)
  else:
    send(1.0 - x)

  i += 1
  x -= step

  time.sleep(0.1)

print('i: ' + str(i))
send(1.0 - x) #REMOVE
sys.exit(0)


###########


x = 0.0
goUp = True

while True:

  if goUp:
    x += step
  else:
    x -= step

  if x > 1.0:
    x = 1.0
    goUp = not goUp

  if x < 0.0:
    x = 0.0
    goUp = not goUp


  data = f2b(x)

  for _ in range(5):
    data += f2b(0.0)

  data = bytearray(b'fxCyanF') + data

  for host in hosts:
    try:
      s.sendto(data, (host, port))
    except:
      pass
  time.sleep(1 / fps)
